import React, { useRef, useState, useEffect } from "react";
import TextField from '@mui/material/TextField';
import MenuItem from '@mui/material/MenuItem';
import 'react-confirm-alert/src/react-confirm-alert.css'; // Import css
import Button from '@mui/material/Button';
import axios from "axios";
import { getCookie, setCookie } from 'react-use-cookie';
import { useHistory } from "react-router-dom";
import { DataGrid, GridToolbar, frFR } from '@mui/x-data-grid';
import "react-draft-wysiwyg/dist/react-draft-wysiwyg.css";
import { Editor } from '@tinymce/tinymce-react';
import parse from 'html-react-parser';
import { FcViewDetails, FcDisapprove } from "react-icons/fc";
import 'react-tooltip/dist/react-tooltip.css'
import { Tooltip } from 'react-tooltip'
import add_plus from "../mysy_img/plus.png";
import excel_icone from "../mysy_img/excel_icone.png";
import participants from "../mysy_img/participants.png";
import fileDownload from 'js-file-download'
import Popup from 'reactjs-popup';
import 'reactjs-popup/dist/index.css';
import { FcSearch } from "react-icons/fc";
import { FcCancel, FcApproval, FcAcceptDatabase, FcPrint, FcAlarmClock, FcMultipleSmartphones, FcWorkflow } from "react-icons/fc";
import DatePicker from "react-datepicker";
import "react-datepicker/dist/react-datepicker.css";
import { format } from 'date-fns'
import moment from "moment";
import InputAdornment from '@mui/material/InputAdornment';
import { AiFillCloseCircle, AiOutlineConsoleSql } from "react-icons/ai";
import Box from '@mui/material/Box';
import { Typography, LinearProgress } from '@mui/material';
import styled from 'styled-components';
import { CiTrash } from "react-icons/ci";
import { MdAddCircleOutline, MdRemoveCircleOutline } from "react-icons/md";
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import { RestoreFromTrashRounded } from "@mui/icons-material";
import img_loading_spin from "./../mysy_img/mysy_spin_loading.gif";
import { Fab } from "@material-ui/core";
import { IoMdAddCircle, IoIosRemoveCircleOutline } from "react-icons/io";
import { AiTwotoneEdit, AiTwotoneSave } from "react-icons/ai";
import { confirmAlert } from 'react-confirm-alert';
import ToggleSwitch from "./ToggleSwitch";
import Module_Historique_Action from "./Module_Historique_Action";
import { HiDocumentCheck } from "react-icons/hi2";
import { BsSend } from "react-icons/bs";
import Autocomplete from '@mui/material/Autocomplete';
import { FcOpenedFolder } from "react-icons/fc";

const Apprenant = (props) => {

    const history = useHistory();
    const [submenu, setsubmenu] = useState("");



    const filters = [
        { value: 'email', label: 'Email' },
        { value: 'nom', label: 'Nom' },
        { value: 'prenom', label: 'Prénom' }
    ]

    const [selectedfilt1, setselectedfilt1] = useState("");
    const [selectedfilt2, setselectedfilt2] = useState("");
    const [selectedfilt3, setselectedfilt3] = useState("");

    const columns = [
        { field: 'id', headerName: 'id', hide: true },
        { field: '_id', headerName: '_id', hide: true },
        { field: 'civilite', headerName: 'Civ.', hide: false, flex: 1, minWidth: 20, maxWidth: 50 },
        { field: 'nom', headerName: 'Nom', hide: false, flex: 1, minWidth: 250 },
        { field: 'prenom', headerName: 'Prénom', hide: false, flex: 1, minWidth: 250 },
        { field: 'email', headerName: 'Email', hide: false, flex: 1, minWidth: 250 },


        {
            field: "Detail", headerName: 'Voir detail',
            renderCell: (cellValues) => {
                return (

                    <Button

                        onClick={(event) => {
                            handleClick_edit_apprenant_From_Line(cellValues.row.id);
                        }}
                    >
                        <FcViewDetails />

                    </Button>

                );
            }
        },

        {
            field: "delete", headerName: 'Supprimer',
            renderCell: (cellValues) => {
                return (

                    <Popup
                        trigger={<Button

                            onClick={(event) => {
                                //handleClick_delete_Session_Formation(event, cellValues);
                            }}
                        >
                            <CiTrash />

                        </Button>}
                        modal
                        nested
                        position="center center"
                    >
                        {close => (
                            <div>
                                <button className="gest_close" onClick={close}>
                                    &times;
                                </button>
                                <div className="gest_header"> MySy Information </div>
                                <div className="gest_content">
                                    {' '}

                                    En confirmant cette opération, la session de formation sera <i><font color="red"> définitivement supprimée</font></i>. <br />

                                </div>
                                <div className="gest_actions">
                                    <div style={{ "width": "45%", "float": "left" }}>
                                        <button className="gest_bton_popup" onClick={(event) => {
                                            //handleClick_delete_Session_Formation(event, cellValues);
                                            //console.log('modal closed ');
                                            close();
                                        }}> Valider </button>

                                    </div>
                                    <div style={{ "width": "45%", "float": "right" }}>
                                        <button
                                            className="gest_bton_popup"
                                            onClick={() => {
                                                //console.log('modal closed ');
                                                close();
                                            }}
                                        >
                                            Annuler
                                        </button>
                                    </div>
                                </div>
                            </div>
                        )}
                    </Popup>


                );
            }
        },


    ]


    const [p_detail_civilite, setp_detail_civilite] = useState("");
    const [p_detail_email, setp_detail_email] = useState("");
    const [p_detail_nom, setp_detail_nom] = useState("");
    const [p_detail_prenom, setp_detail_prenom] = useState("");
    const [p_detail_telephone, setp_detail_telephone] = useState("");
    const [p_detail_employeur, setp_detail_employeur] = useState("");
    const [p_detail_client_rattachement_id, setp_detail_client_rattachement_id] = useState("");
    const [p_detail_adresse, setp_detail_adresse] = useState("");
    const [p_detail_code_postal, setp_detail_code_postal] = useState("");
    const [p_detail_ville, setp_detail_ville] = useState("");
    const [p_detail_pays, setp_detail_pays] = useState("");
    const [p_detail_tuteur1_nom, setp_detail_tuteur1_nom] = useState("");
    const [p_detail_tuteur1_prenom, setp_detail_tuteur1_prenom] = useState("");
    const [p_detail_tuteur1_email, setp_detail_tuteur1_email] = useState("");
    const [p_detail_tuteur1_telephone, setp_detail_tuteur1_telephone] = useState("");
    const [p_detail_tuteur1_adresse, setp_detail_tuteur1_adresse] = useState("");
    const [p_detail_tuteur1_cp, setp_detail_tuteur1_cp] = useState("");
    const [p_detail_tuteur1_ville, setp_detail_tuteur1_ville] = useState("");
    const [p_detail_tuteur1_pays, setp_detail_tuteur1_pays] = useState("");
    const [p_detail_tuteur1_include_com, setp_detail_tuteur1_include_com] = useState("");
    const [p_detail_tuteur2_nom, setp_detail_tuteur2_nom] = useState("");
    const [p_detail_tuteur2_prenom, setp_detail_tuteur2_prenom] = useState("");
    const [p_detail_tuteur2_email, setp_detail_tuteur2_email] = useState("");
    const [p_detail_tuteur2_telephone, setp_detail_tuteur2_telephone] = useState("");
    const [p_detail_tuteur2_adresse, setp_detail_tuteur2_adresse] = useState("");
    const [p_detail_tuteur2_cp, setp_detail_tuteur2_cp] = useState("");
    const [p_detail_tuteur2_ville, setp_detail_tuteur2_ville] = useState("");
    const [p_detail_tuteur2_pays, setp_detail_tuteur2_pays] = useState("");
    const [p_detail_tuteur2_include_com, setp_detail_tuteur2_include_com] = useState("");
    const [p_detail_date_creation, setp_detail_date_creation] = useState("");


    const [p_one_civilite, setp_one_civilite] = useState("");
    const [p_one_email, setp_one_email] = useState("");
    const [p_one_nom, setp_one_nom] = useState("");
    const [p_one_prenom, setp_one_prenom] = useState("");
    const [p_one_telephone, setp_one_telephone] = useState("");
    const [p_one_employeur, setp_one_employeur] = useState("");
    const [p_one_client_rattachement_id, setp_one_client_rattachement_id] = useState("");
    const [p_one_adresse, setp_one_adresse] = useState("");
    const [p_one_code_postal, setp_one_code_postal] = useState("");
    const [p_one_ville, setp_one_ville] = useState("");
    const [p_one_pays, setp_one_pays] = useState("");
    const [p_one_tuteur1_nom, setp_one_tuteur1_nom] = useState("");
    const [p_one_tuteur1_prenom, setp_one_tuteur1_prenom] = useState("");
    const [p_one_tuteur1_email, setp_one_tuteur1_email] = useState("");
    const [p_one_tuteur1_telephone, setp_one_tuteur1_telephone] = useState("");
    const [p_one_tuteur1_adresse, setp_one_tuteur1_adresse] = useState("");
    const [p_one_tuteur1_cp, setp_one_tuteur1_cp] = useState("");
    const [p_one_tuteur1_ville, setp_one_tuteur1_ville] = useState("");
    const [p_one_tuteur1_pays, setp_one_tuteur1_pays] = useState("");
    const [p_one_tuteur1_include_com, setp_one_tuteur1_include_com] = useState("");
    const [p_one_tuteur2_nom, setp_one_tuteur2_nom] = useState("");
    const [p_one_tuteur2_prenom, setp_one_tuteur2_prenom] = useState("");
    const [p_one_tuteur2_email, setp_one_tuteur2_email] = useState("");
    const [p_one_tuteur2_telephone, setp_one_tuteur2_telephone] = useState("");
    const [p_one_tuteur2_adresse, setp_one_tuteur2_adresse] = useState("");
    const [p_one_tuteur2_cp, setp_one_tuteur2_cp] = useState("");
    const [p_one_tuteur2_ville, setp_one_tuteur2_ville] = useState("");
    const [p_one_tuteur2_pays, setp_one_tuteur2_pays] = useState("");
    const [p_one_tuteur2_include_com, setp_one_tuteur2_include_com] = useState("");

    const [field_detail_civilite, setfield_detail_civilite] = useState("");
    const [field_detail_email, setfield_detail_email] = useState("");
    const [field_detail_nom, setfield_detail_nom] = useState("");
    const [field_detail_prenom, setfield_detail_prenom] = useState("");
    const [field_detail_telephone, setfield_detail_telephone] = useState("");
    const [field_detail_employeur, setfield_detail_employeur] = useState("");
    const [field_detail_client_rattachement_id, setfield_detail_client_rattachement_id] = useState("");
    const [field_detail_adresse, setfield_detail_adresse] = useState("");
    const [field_detail_code_postal, setfield_detail_code_postal] = useState("");
    const [field_detail_ville, setfield_detail_ville] = useState("");
    const [field_detail_pays, setfield_detail_pays] = useState("");
    const [field_detail_tuteur1_nom, setfield_detail_tuteur1_nom] = useState("");
    const [field_detail_tuteur1_prenom, setfield_detail_tuteur1_prenom] = useState("");
    const [field_detail_tuteur1_email, setfield_detail_tuteur1_email] = useState("");
    const [field_detail_tuteur1_telephone, setfield_detail_tuteur1_telephone] = useState("");


    const [field_detail_tuteur1_adresse, setfield_detail_tuteur1_adresse] = useState("");
    const [field_detail_tuteur1_cp, setfield_detail_tuteur1_cp] = useState("");
    const [field_detail_tuteur1_ville, setfield_detail_tuteur1_ville] = useState("");
    const [field_detail_tuteur1_pays, setfield_detail_tuteur1_pays] = useState("");
    const [field_detail_tuteur1_include_com, setfield_detail_tuteur1_include_com] = useState("");


    const [field_detail_tuteur2_nom, setfield_detail_tuteur2_nom] = useState("");
    const [field_detail_tuteur2_prenom, setfield_detail_tuteur2_prenom] = useState("");
    const [field_detail_tuteur2_email, setfield_detail_tuteur2_email] = useState("");
    const [field_detail_tuteur2_telephone, setfield_detail_tuteur2_telephone] = useState("");



    const [field_detail_tuteur2_adresse, setfield_detail_tuteur2_adresse] = useState("");
    const [field_detail_tuteur2_cp, setfield_detail_tuteur2_cp] = useState("");
    const [field_detail_tuteur2_ville, setfield_detail_tuteur2_ville] = useState("");
    const [field_detail_tuteur2_pays, setfield_detail_tuteur2_pays] = useState("");
    const [field_detail_tuteur2_include_com, setfield_detail_tuteur2_include_com] = useState("");




    const [selected_apprenant_id, setselected_apprenant_id] = useState();
    const [selected_apprenant_row_id, setselected_apprenant_row_id] = useState();



    const [Get_Current_Apprenant_Data_api, setGet_Current_Apprenant_Data_api] = useState();
    const [Get_Current_Apprenant_Data_message, setGet_Current_Apprenant_Data_message] = useState();
    const [Get_Current_Apprenant_Data_result, setGet_Current_Apprenant_Data_result] = useState();
    function Get_Current_Apprenant_Data(local_selected_apprenant_id) {

        var my_id = local_selected_apprenant_id;
        if (selected_apprenant_id)
            my_id = selected_apprenant_id

        Clear_Detail_Apprenant_Fields();

        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("_id", my_id);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Given_Apprenant_Data/";

        setLoading(true);
        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === "true") {
                //console.log(" In Get_Current_Apprenant_Data  res.data.status = " + res.data.status);
                //console.log(" In Get_Current_Apprenant_Data  res.data.message r_class = " + res.data.message);
                //console.log(" In Get_Current_Apprenant_Data  res.data.message len = " + String(res.data.message).length);

                setLoading(false);
                setGet_Current_Apprenant_Data_api("true");
                if (String(res.data.message).length > 0) {
                    setGet_Current_Apprenant_Data_result(res.data.message);
                    var mylocaltraining = JSON.parse(res.data.message);

                    if (mylocaltraining.civilite) {
                        setp_detail_civilite(mylocaltraining.civilite);
                    }

                    if (mylocaltraining.email) {
                        setp_detail_email(mylocaltraining.email);
                    }

                    if (mylocaltraining.nom) {
                        setp_detail_nom(mylocaltraining.nom);
                    }

                    if (mylocaltraining.prenom) {
                        setp_detail_prenom(mylocaltraining.prenom);
                    }

                    if (mylocaltraining.telephone) {
                        setp_detail_telephone(mylocaltraining.telephone);
                    }

                    if (mylocaltraining.employeur) {
                        setp_detail_employeur(mylocaltraining.employeur);
                    }

                    if (mylocaltraining.client_rattachement_id) {
                        setp_detail_client_rattachement_id(mylocaltraining.client_rattachement_id);
                    }

                    if (mylocaltraining.adresse) {
                        setp_detail_adresse(mylocaltraining.adresse);
                    }

                    if (mylocaltraining.code_postal) {
                        setp_detail_code_postal(mylocaltraining.code_postal);
                    }

                    if (mylocaltraining.ville) {
                        setp_detail_ville(mylocaltraining.ville);
                    }

                    if (mylocaltraining.pays) {
                        setp_detail_pays(mylocaltraining.pays);
                    }

                    if (mylocaltraining.tuteur1_nom) {
                        setp_detail_tuteur1_nom(mylocaltraining.tuteur1_nom);
                    }

                    if (mylocaltraining.tuteur1_prenom) {
                        setp_detail_tuteur1_prenom(mylocaltraining.tuteur1_prenom);
                    }

                    if (mylocaltraining.tuteur1_email) {
                        setp_detail_tuteur1_email(mylocaltraining.tuteur1_email);
                    }

                    if (mylocaltraining.tuteur1_telephone) {
                        setp_detail_tuteur1_telephone(mylocaltraining.tuteur1_telephone);
                    }

                    if (mylocaltraining.tuteur1_adresse) {
                        setp_detail_tuteur1_adresse(mylocaltraining.tuteur1_adresse);
                    }

                    if (mylocaltraining.tuteur1_cp) {
                        setp_detail_tuteur1_cp(mylocaltraining.tuteur1_cp);
                    }

                    if (mylocaltraining.tuteur1_ville) {
                        setp_detail_tuteur1_ville(mylocaltraining.tuteur1_ville);
                    }

                    if (mylocaltraining.tuteur1_pays) {
                        setp_detail_tuteur1_pays(mylocaltraining.tuteur1_pays);
                    }

                    if (mylocaltraining.tuteur1_include_com) {
                        setp_detail_tuteur1_include_com(mylocaltraining.tuteur1_include_com);
                    }

                    if (mylocaltraining.tuteur2_nom) {
                        setp_detail_tuteur2_nom(mylocaltraining.tuteur2_nom);
                    }

                    if (mylocaltraining.tuteur2_prenom) {
                        setp_detail_tuteur2_prenom(mylocaltraining.tuteur2_prenom);
                    }

                    if (mylocaltraining.tuteur2_email) {
                        setp_detail_tuteur2_email(mylocaltraining.tuteur2_email);
                    }

                    if (mylocaltraining.tuteur2_telephone) {
                        setp_detail_tuteur2_telephone(mylocaltraining.tuteur2_telephone);
                    }

                    if (mylocaltraining.tuteur2_adresse) {
                        setp_detail_tuteur2_adresse(mylocaltraining.tuteur2_adresse);
                    }

                    if (mylocaltraining.tuteur2_cp) {
                        setp_detail_tuteur2_cp(mylocaltraining.tuteur2_cp);
                    }

                    if (mylocaltraining.tuteur2_ville) {
                        setp_detail_tuteur2_ville(mylocaltraining.tuteur2_ville);
                    }

                    if (mylocaltraining.tuteur2_pays) {
                        setp_detail_tuteur2_pays(mylocaltraining.tuteur2_pays);
                    }

                    if (mylocaltraining.tuteur2_include_com) {
                        setp_detail_tuteur2_include_com(mylocaltraining.tuteur2_include_com);
                    }

                    if (mylocaltraining.date_creation) {
                        setp_detail_date_creation(mylocaltraining.date_creation);
                    }


                    /*
               * Update 22/10/2023 :
               Gestion des champs spécifiques. ils commencent tous par 'my_'
               */

                    for (let i = 0; i < rows_champs_specifics.length; i++) {

                        var field_name = JSON.parse(rows_champs_specifics[i]).field_name;
                        var field_type = JSON.parse(rows_champs_specifics[i]).field_type;
                        var field_label = JSON.parse(rows_champs_specifics[i]).field_label;
                        var is_mandatory = JSON.parse(rows_champs_specifics[i]).is_mandatory;



                        if (mylocaltraining.hasOwnProperty(field_name)) {
                            var local_valeur = mylocaltraining[String(field_name)]

                            if (document.getElementById(String(field_name)))
                                document.getElementById(String(field_name)).value = local_valeur;

                            var new_val = { 'field_name': field_name, 'field_value': local_valeur, 'field_type': field_type, 'field_label': field_label, 'is_mandatory': is_mandatory }
                            var johnIndex = findIndexByProperty(spec_field_updated_values, 'field_name', field_name);

                            if (johnIndex > -1) {
                                spec_field_updated_values[johnIndex] = new_val;

                            } else {
                                spec_field_updated_values.push(new_val);
                            }

                        } else {

                        }
                    }

                    setspec_field_updated_values_hooks(spec_field_updated_values);
                    /*
                                       *  end Update 22/10/2023 :
                                       */


                    Disable_Detail_Apprenant_Fields();


                    if (document.getElementById('detail_apprenant')) {
                        // myRef.current.scrollIntoView({ behavior: "smooth" });
                        var divh = document.getElementById('detail_apprenant').offsetTop;
                        window.scrollTo({
                            top: divh,
                            behavior: "smooth",
                        });
                    }
                }

            } else if (String(res.data.status) === String("Err_Connexion")) {
                setLoading(false);
                alert('Erreur: ' + res.data.message);
                history.push("/Connexion");
            }

            else {
                setLoading(false);
                setGet_Current_Apprenant_Data_api("false");
                setGet_Current_Apprenant_Data_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            setLoading(false);
            console.warn('Not good man :( Get_Current_Apprenant_Data = ', error);
            setGet_Current_Apprenant_Data_api("false");
            alert(" Impossible de récuperer les données de l'apprenant ");

        })
    }


    const [Get_List_Of_All_PJ_api, setGet_List_Of_All_PJ_api] = useState();
    const [Get_List_Of_All_PJ_result, setGet_List_Of_All_PJ_result] = useState();
    const [Get_List_Of_All_PJ_message, setGet_List_Of_All_PJ_message] = useState();

    function Get_List_Of_All_PJ(local_employee_id) {

        const formData = new FormData();

        //formData.append('token', 'K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA');
        const stored_cookie = getCookie('tokenmysypart');

        formData.append("token", stored_cookie);
        formData.append("object_owner_collection", "inscription");
        formData.append("object_owner_id", local_employee_id);


        //formData.append("class_internal_url", internal_url);
        //console.log("token = " + stored_cookie);
        setLoading(true);

        fetch(
            process.env.REACT_APP_API_URL + "myclass/api/Get_List_object_owner_collection_Stored_Files/",
            {
                method: 'POST',
                body: formData,
            }
        )
            .then((response) => response.json())
            .then((result) => {
                setLoading(false);

                //console.log(" ## result['status'] = ", result['status'])
                if (String(result['status']) === String("true")) {
                    //console.log('Message :', result['message']);
                    setGet_List_Of_All_PJ_result(result['message']);
                    setGet_List_Of_All_PJ_api("true");

                }
                else {
                    setGet_List_Of_All_PJ_message(result['message']);
                    setGet_List_Of_All_PJ_api("false");
                }

            })
            .catch((error) => {
                setLoading(false);
                console.error(' Get_List_Of_All_PJ Error:', error);
                setGet_List_Of_All_PJ_api("false");
            });

    }



    const [getPartnerImages_api, setgetPartnerImages_api] = useState();
    const [getPartnerImages_message, setgetPartnerImages_message] = useState();
    const [getPartnerImages_result, setgetPartnerImages_result] = useState();
    function Get_Apprenant_Images(local_selected_apprenant_id) {

        var my_id = local_selected_apprenant_id;
        if (selected_apprenant_id)
            my_id = selected_apprenant_id

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Apprenant_Recorded_Image_from_front/";

        var form = new FormData();
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("apprenant_id", my_id);



        axios.post(myurl, form).then(res => {

            //console.log(" Get_Apprenant_Images : In test  res.data.status = " + res.data.status);
            // console.log(" Get_Apprenant_Images: res.data.message.img = " + res.data.message);

            if (String(res.data.status) === "true") {
                setgetPartnerImages_api("true");

                if (JSON.parse(res.data.message).logo_img) {
                    var partner_logo_img = "data:image/png;base64," + JSON.parse(res.data.message).logo_img;
                    setisimgclassSelected(partner_logo_img);
                    setuserimgclassprofil(partner_logo_img);
                    setisimgclassSelected_recid(JSON.parse(res.data.message).logo_img_recid);
                }


            }
            else if (String(res.data.status) === String("Err_Connexion")) {
                alert('Erreur: ' + res.data.message);
                history.push("/Connexion");
                return;
            }
            else {
                setgetPartnerImages_api("false");
                setgetPartnerImages_message(res.data.message)

            }
        }).catch((error) => {
            console.warn('Get_Apprenant_Images ee: Not good man :(  = ', error);
            setgetPartnerImages_api("false");
            setgetPartnerImages_message(" Impossible de recuperer les images/médias de l'apprenant")
        })

    }

    function findIndexByProperty(data, key, value) {
        for (var i = 0; i < data.length; i++) {

            if (data[i][key] == value) {
                return i;
            }
        }
        return -1;
    }


    function Clear_Detail_Apprenant_Fields() {

        setfield_detail_civilite('');
        setfield_detail_email('');
        setfield_detail_nom('');
        setfield_detail_prenom('');
        setfield_detail_telephone('');
        setfield_detail_employeur('');
        setfield_detail_client_rattachement_id('');
        setfield_detail_adresse('');
        setfield_detail_code_postal('');
        setfield_detail_ville('');
        setfield_detail_pays('');

        setfield_detail_tuteur1_nom('');
        setfield_detail_tuteur1_prenom('');
        setfield_detail_tuteur1_email('');
        setfield_detail_tuteur1_telephone('');
        setfield_detail_tuteur2_nom('');
        setfield_detail_tuteur2_prenom('');
        setfield_detail_tuteur2_email('');
        setfield_detail_tuteur2_telephone('');


    }


    function Disable_Detail_Apprenant_Fields() {


        if (document.getElementsByName("field_detail_civilite") && document.getElementsByName("field_detail_civilite")[0]) {
            document.getElementsByName("field_detail_civilite")[0].disabled = true;
            document.getElementsByName("field_detail_civilite")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_email") && document.getElementsByName("field_detail_email")[0]) {
            document.getElementsByName("field_detail_email")[0].disabled = true;
            document.getElementsByName("field_detail_email")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_nom") && document.getElementsByName("field_detail_nom")[0]) {
            document.getElementsByName("field_detail_nom")[0].disabled = true;
            document.getElementsByName("field_detail_nom")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_prenom") && document.getElementsByName("field_detail_prenom")[0]) {
            document.getElementsByName("field_detail_prenom")[0].disabled = true;
            document.getElementsByName("field_detail_prenom")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_telephone") && document.getElementsByName("field_detail_telephone")[0]) {
            document.getElementsByName("field_detail_telephone")[0].disabled = true;
            document.getElementsByName("field_detail_telephone")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_employeur") && document.getElementsByName("field_detail_employeur")[0]) {
            document.getElementsByName("field_detail_employeur")[0].disabled = true;
            document.getElementsByName("field_detail_employeur")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_adresse") && document.getElementsByName("field_detail_adresse")[0]) {
            document.getElementsByName("field_detail_adresse")[0].disabled = true;
            document.getElementsByName("field_detail_adresse")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_code_postal") && document.getElementsByName("field_detail_code_postal")[0]) {
            document.getElementsByName("field_detail_code_postal")[0].disabled = true;
            document.getElementsByName("field_detail_code_postal")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_ville") && document.getElementsByName("field_detail_ville")[0]) {
            document.getElementsByName("field_detail_ville")[0].disabled = true;
            document.getElementsByName("field_detail_ville")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_pays") && document.getElementsByName("field_detail_pays")[0]) {
            document.getElementsByName("field_detail_pays")[0].disabled = true;
            document.getElementsByName("field_detail_pays")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur1_nom") && document.getElementsByName("field_detail_tuteur1_nom")[0]) {
            document.getElementsByName("field_detail_tuteur1_nom")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur1_nom")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur1_nom") && document.getElementsByName("field_detail_tuteur1_nom")[0]) {
            document.getElementsByName("field_detail_tuteur1_nom")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur1_nom")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur1_prenom") && document.getElementsByName("field_detail_tuteur1_prenom")[0]) {
            document.getElementsByName("field_detail_tuteur1_prenom")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur1_prenom")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur1_email") && document.getElementsByName("field_detail_tuteur1_email")[0]) {
            document.getElementsByName("field_detail_tuteur1_email")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur1_email")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur1_telephone") && document.getElementsByName("field_detail_tuteur1_telephone")[0]) {
            document.getElementsByName("field_detail_tuteur1_telephone")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur1_telephone")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur2_nom") && document.getElementsByName("field_detail_tuteur2_nom")[0]) {
            document.getElementsByName("field_detail_tuteur2_nom")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur2_nom")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur2_prenom") && document.getElementsByName("field_detail_tuteur2_prenom")[0]) {
            document.getElementsByName("field_detail_tuteur2_prenom")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur2_prenom")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur2_email") && document.getElementsByName("field_detail_tuteur2_email")[0]) {
            document.getElementsByName("field_detail_tuteur2_email")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur2_email")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("field_detail_tuteur2_telephone") && document.getElementsByName("field_detail_tuteur2_telephone")[0]) {
            document.getElementsByName("field_detail_tuteur2_telephone")[0].disabled = true;
            document.getElementsByName("field_detail_tuteur2_telephone")[0].style.backgroundColor = "#ECEFF1";
        }



    }

    const spec_field_updated_values = []
    const [spec_field_updated_values_hooks, setspec_field_updated_values_hooks] = useState([]);


    function handleClick_edit_apprenant_From_Line(selected_row_id) {


        var line = JSON.parse(Get_All_Apprenant_result[selected_row_id]);

        setadd_One_Apprenant('');
        setdisplay_detail_apprenant('1');


        setselected_apprenant_id(line._id);
        Get_Current_Apprenant_Data(line._id);
        Get_Apprenant_Images(line._id);
        Get_List_Of_All_PJ(line._id);
    }


    const sleep = (milliseconds) => {
        return new Promise(resolve => setTimeout(resolve, milliseconds))
    }


    const [isimgclassSelected, setisimgclassSelected] = useState(false);
    const [isimgclassSelected_recid, setisimgclassSelected_recid] = useState("");
    const [isimgclassSelectedfile, setisimgclassSelectedfile] = useState(false);


    const [isimgclassdeleted, setisimgclassdeleted] = useState("");
    const [isimgclassdeleted_message, setisimgclassdeleted_message] = useState("");
    const [isimgclassSaved, setisimgclassSaved] = useState("");
    const [isimgclassSaved_message, setisimgclassSaved_message] = useState("");


    const [userimgclassprofil, setuserimgclassprofil] = useState();
    const [userimgclassprofilchanged, setuserimgclassprofilchanged] = useState("");



    const [isLoading, setLoading] = useState();
    const [Dialog_1_message, setDialog_1_message] = React.useState(false);
    const [Dialog_1_open, setDialog_1_open] = React.useState(false);
    function Dialog_1_handle_change_participant_session(message) {
        setDialog_1_message(message);
        setDialog_1_open(true);
    }

    const Dialog_1_handleClose = () => {

    };

    const Dialog_1_handleClose_buton = () => {
        setDialog_1_open(false);
    };



    const [Dialog_2_message, setDialog_2_message] = React.useState(false);
    const [Dialog_2_open, setDialog_2_open] = React.useState(false);
    function Dialog_2_handle_change_participant_session(message) {
        setDialog_2_message(message);
        setDialog_2_open(true);
    }

    const Dialog_2_handleClose = () => {

    };

    const Dialog_2_handleClose_buton = () => {
        setDialog_2_open(false);
    };

    const [actionmass_ftion_val, setactionmass_ftion_val] = useState();
    const actionmass_ftion = (event) => {
        const value = event.target.value;


        if (String(value) === "supprimer" || String(value) === "dupliquer" || String(value) === "desactiver") {
            setactionmass_ftion_val(value);
        }
        else {
            setactionmass_ftion_val();
        }
    }

    async function actionmass_ftion_Traitemet() {


        var liste_session = GetSelectedRowsSession();

        //console.log(" liste_formation = ", liste_formation);
        //console.log(" actionmass_ftion_val = ", actionmass_ftion_val);

        if (String(actionmass_ftion_val) === String("supprimer")) {

            //console.log(" ### liste session : ", liste_session)
            //Delete_LIST_Session_Formation(liste_session);

        }

        else if (String(actionmass_ftion_val) === String("dupliquer")) {
            //Dupliquer_LIST_Session_Formation(liste_session);
        }

        else if (String(actionmass_ftion_val) === String("publier")) {

        }

        else if (String(actionmass_ftion_val) === String("desactiver")) {

        }

    }

    const [rows_champs_specifics_stagiaire, setrows_champs_specifics_stagiaire] = useState([]);

    function GetSelectedRowsSession() {
        ///alert(" les lignes slected sont :  " + selectionModel + " nb item = " + selectionModel.length);
        //const selectedRowsData = selectionModel.map((id) => rowss.find((row) => row.id === id));
        //console.log(rowss[0]);
        var tab_tmp = []
        for (var i = 0; i < selectionModel.length; i++) {
            var myid = parseInt(String(selectionModel[i]));
            var line = JSON.parse(Get_All_Apprenant_result[myid]);
            tab_tmp.push(line._id);
            //console.log(rowss[myid]['external_code']);
        }

        setselectedtraining(tab_tmp);
        return tab_tmp;

    }

    const [selectedtraining, setselectedtraining] = useState([])


    const [gridline_id, setgridline_id] = useState("");
    const [Get_Partner_Object_Specific_Fields_apprenant_api, setGet_Partner_Object_Specific_Fields_apprenant_api] = useState();
    const [Get_Partner_Object_Specific_Fields_apprenant_message, setGet_Partner_Object_Specific_Fields_apprenant_message] = useState();
    const [Get_Partner_Object_Specific_Fields_apprenant_result, setGet_Partner_Object_Specific_Fields_apprenant_result] = useState();
    function Get_Partner_Object_Specific_Fields_apprenant() {

        var form = new FormData();
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("object_name", "apprenant");

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Partner_Object_Specific_Valide_Displayed_Fields/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In Get_Partner_Object_Specific_Fields  res.data.status = " + res.data.status);
                //console.log(" In Get_Partner_Object_Specific_Fields  res.data.message r_class = " + res.data.message);

                setGet_Partner_Object_Specific_Fields_apprenant_api("true");
                setGet_Partner_Object_Specific_Fields_apprenant_result(res.data.message);


                setrows_champs_specifics_stagiaire(res.data.message);


            }
            else {
                setGet_Partner_Object_Specific_Fields_apprenant_api("false");
                setGet_Partner_Object_Specific_Fields_apprenant_message(res.data.message);
                alert(res.data.message)
            }

        }).catch((error) => {
            console.warn('Not good man :( Get_Partner_Object_Specific_Fields = ', error);
            setGet_Partner_Object_Specific_Fields_apprenant_api("false");
            alert(" Impossible de recuperer la liste des collection et champs personnalisables");
            //setmyApimyApiMessage("")
        })
    }

    const [rows_champs_specifics, setrows_champs_specifics] = useState([]);

    const [New_Getall_Training_Employee_No_Filter_result, setNew_Getall_Training_Employee_No_Filter_result] = useState([]);

    const [Getall_Training_Employee_No_Filter_api, setGetall_Training_Employee_No_Filter_api] = useState();
    const [Getall_Training_Employee_No_Filter_message, setGetall_Training_Employee_No_Filter_message] = useState();
    const [Getall_Training_Employee_No_Filter_result, setGetall_Training_Employee_No_Filter_result] = useState();
    function Getall_Training_Employee_No_Filter(event) {

        var form = new FormData();


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_List_Ressource_Humaine_no_filter/";

        setLoading(true);
        axios.post(myurl, form).then(res => {

            setLoading(false);
            if (String(res.data.status) === String("true")) {
                //console.log(" In Getall_Training_Employee_No_Filter  res.data.status = " + res.data.status);
                //console.log(" In Getall_Training_Employee_No_Filter  res.data.message r_class = " + res.data.message);
                setGetall_Training_Employee_No_Filter_api("true");
                setGetall_Training_Employee_No_Filter_result(res.data.message);

                var new_data2 = [];
                const new_data = res.data.message.map((x) => {

                    //---
                    var localid = JSON.parse(x).id;
                    var local_id = JSON.parse(x)._id;
                    var local_nom = JSON.parse(x).nom;
                    var local_prenom = JSON.parse(x).prenom;
                    var local_ismanager = JSON.parse(x).ismanager;


                    //---
                    var node = {
                        "_id": local_id,
                        "id": localid,
                        "label": local_nom + " " + local_prenom,
                        "nom": local_nom,
                        "prenom": local_prenom,
                        "ismanager": local_ismanager
                    };
                    new_data2.push(node);
                });

                if (new_data2.length > 0)
                    setNew_Getall_Training_Employee_No_Filter_result(new_data2);

            }
            else {
                setGetall_Training_Employee_No_Filter_api("false");
                setGetall_Training_Employee_No_Filter_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            setLoading(false);
            console.warn('Not good man :( Getall_Training_Employee_No_Filter = ', error);
            setGetall_Training_Employee_No_Filter_api("false");
            alert(" Impossible de recuperer la liste des employés");
            //setmyApimyApiMessage("")
        })
    }


    const [Getall_Training_Materiel_No_Filter_api, setGetall_Training_Materiel_No_Filter_api] = useState();
    const [Getall_Training_Materiel_No_Filter_message, setGetall_Training_Materiel_No_Filter_message] = useState();
    const [Getall_Training_Materiel_No_Filter_result, setGetall_Training_Materiel_No_Filter_result] = useState();
    function Getall_Training_Materiel_No_Filter(event) {

        var form = new FormData();


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_List_Ressource_Materielle_no_filter/";

        setLoading(true);

        axios.post(myurl, form).then(res => {


            setLoading(false);
            if (String(res.data.status) === String("true")) {
                //console.log(" In Getall_Training_Materiel_No_Filter  res.data.status = " + res.data.status);
                //console.log(" In Getall_Training_Materiel_No_Filter  res.data.message r_class = " + res.data.message);
                setGetall_Training_Materiel_No_Filter_api("true");
                setGetall_Training_Materiel_No_Filter_result(res.data.message);
            }
            else {
                setGetall_Training_Materiel_No_Filter_api("false");
                setGetall_Training_Materiel_No_Filter_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {

            setLoading(false);
            console.warn('Not good man :( Getall_Training_Materiel_No_Filter = ', error);
            setGetall_Training_Materiel_No_Filter_api("false");
            alert(" Impossible de recuperer la liste du materiel");
            //setmyApimyApiMessage("")
        })
    }


    const [Get_All_Apprenant_api, setGet_All_Apprenant_api] = useState();
    const [Get_All_Apprenant_message, setGet_All_Apprenant_message] = useState();
    const [Get_All_Apprenant_result, setGet_All_Apprenant_result] = useState([]);
    function Get_All_Apprenant(event) {

        var form = new FormData();


        // Recuperation des parametres
        var filtre1 = p_filtre1;
        var filtre2 = p_filtre2;


        var filtre1_value = "";
        var filtre2_value = "";
        var filtre3_value = "";
        // Recuperation des valeurs de filtres

        if (p_filtre1_value) {
            filtre1_value = p_filtre1_value;
            form.append(filtre1, filtre1_value);
        }

        if (p_filtre2_value) {
            filtre2_value = p_filtre2_value;
            form.append(filtre2, filtre2_value);
        }


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_List_Partner_Apprenant/";


        // Verification s'il faut faire une recherche avec une option like.
        //console.log(" p_filtre1 = ", p_filtre1, "   filtre1_value = ", filtre1_value);

        if (p_filtre1_value || p_filtre2_value) {
            myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Apprenant_List_Partner_with_filter/";
        }


        setLoading(true);
        axios.post(myurl, form).then(res => {
            setLoading(false);
            if (String(res.data.status) === String("true")) {
                //console.log(" In Get_All_Apprenant  res.data.status = " + res.data.status);
                //console.log(" In Get_All_Apprenant  res.data.message r_class = " + res.data.message);
                setGet_All_Apprenant_api("true");
                setGet_All_Apprenant_result(res.data.message);
            }
            else {
                setGet_All_Apprenant_api("false");
                setGet_All_Apprenant_message(res.data.message);
                alert(res.data.message)
            }

        }).catch((error) => {
            setLoading(false);
            console.warn('Not good man :( Get_All_Apprenant = ', error);
            setGet_All_Apprenant_api("false");
            alert("Impossible de récuperer la liste des apprenants");
            //setmyApimyApiMessage("")
        })
    }

    const [Get_List_Partner_Clients_api, setGet_List_Partner_Clients_api] = useState();
    const [Get_List_Partner_Clients_message, setGet_List_Partner_Clients_message] = useState();
    const [Get_List_Partner_Clients_result, setGet_List_Partner_Clients_result] = useState();
    function Get_List_Partner_Clients(event) {

        var form = new FormData();
        const stored_cookie = getCookie('tokenmysypart');

        form.append("token", stored_cookie);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Partner_List_Partner_Client/";

        axios.post(myurl, form).then(res => {
            //console.log(" In Get_List_Partner_Clients  res.data.status = " + res.data.status);
            //console.log(" In Get_List_Partner_Clients  res.data.message r_class = " + res.data.message);

            if (String(res.data.status) === String("true")) {
                setGet_List_Partner_Clients_api("true");
                setGet_List_Partner_Clients_result(res.data.message);
            }
            else if (String(res.data.status) === String("Err_Connexion")) {
                alert('Erreur: ' + res.data.message);
                history.push("/Connexion");
            }
            else {
                setGet_List_Partner_Clients_api("false");
                setGet_List_Partner_Clients_message(res.data.message);
                alert('Erreur: ' + res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Get_List_Partner_Clients = ', error);
            setGet_List_Partner_Clients_api("false");
            alert('Erreur: Impossible de recuperer la liste des clients');
        })
    }

    const [Get_Partner_Object_Specific_Fields_api, setGet_Partner_Object_Specific_Fields_api] = useState();
    const [Get_Partner_Object_Specific_Fields_message, setGet_Partner_Object_Specific_Fields_message] = useState();
    const [Get_Partner_Object_Specific_Fields_result, setGet_Partner_Object_Specific_Fields_result] = useState();
    function Get_Partner_Object_Specific_Fields(local_collection_obj_metier) {

        var form = new FormData();
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("object_name", local_collection_obj_metier);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Partner_Object_Specific_Valide_Displayed_Fields/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In Get_Partner_Object_Specific_Fields  res.data.status = " + res.data.status);
                //console.log(" In Get_Partner_Object_Specific_Fields  res.data.message r_class = " + res.data.message);

                setGet_Partner_Object_Specific_Fields_api("true");
                setGet_Partner_Object_Specific_Fields_result(res.data.message);


                setrows_champs_specifics(res.data.message);


            }
            else {
                setGet_Partner_Object_Specific_Fields_api("false");
                setGet_Partner_Object_Specific_Fields_message(res.data.message);
                alert(res.data.message)
            }

        }).catch((error) => {
            console.warn('Not good man :( Get_Partner_Object_Specific_Fields = ', error);
            setGet_Partner_Object_Specific_Fields_api("false");
            alert(" Impossible de recuperer la liste des collection et champs personnalisables");
            //setmyApimyApiMessage("")
        })
    }

    const myRef_details = useRef(null)

    useEffect(() => {


        Get_Partner_Object_Specific_Fields_apprenant();

        Getall_Training_Employee_No_Filter();
        Getall_Training_Materiel_No_Filter();
        Get_List_Partner_Clients();

        Get_All_Apprenant();

        window.scrollTo({
            top: 0,
            behavior: "smooth",
        });

        /*
        if (String(props.object_key).length > 3) {

            setLoading(true);
            GetCurrentSession(props.object_key, props.class_internal_url);
            Display_session_From_Props(props.object_key, props.class_internal_url);
            setLoading(false);
        } else {
            window.scrollTo({
                top: 0,
                behavior: "smooth",
            });
        }
*/

    }, [])


    const [selectionModel, setSelectionModel] = React.useState([]);
    const [p_filtre1, setp_filtre1] = useState();
    const [p_filtre1_value, setp_filtre1_value] = useState();

    const [p_filtre2, setp_filtre2] = useState();
    const [p_filtre2_value, setp_filtre2_value] = useState();

    function clean_all_filters() {

        setSelectionModel([]);
        setGet_All_Apprenant_result([]);

        setsubmenu("");

        Get_All_Apprenant();
    }


    const [apprenant_file_name, setapprenant_file_name] = useState();

    const [liste_apprenants_file_change_api, setliste_apprenants_file_change_api] = useState();
    const [liste_apprenants_file_change_result, setliste_apprenants_file_change_result] = useState();
    const [liste_apprenants_file_change_message, setliste_apprenants_file_change_message] = useState();
    const liste_apprenants_file_change = event => {

        const fileUploaded = event.target.files[0];
        let file_size = event.target.files[0].size;
        let file_type = event.target.files[0].type;

        //console.log("file_size =  ",file_size," file_type = ",file_type);
        if (file_size > 1000000) {
            alert("Le fichier ne doit pas dépasser un 1 Méga octets");
            return;
        }

        setapprenants_file_name(event.target.files[0].name);

        const formData = new FormData();
        formData.append('File', fileUploaded);
        //formData.append('token', 'K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA');
        const stored_cookie = getCookie('tokenmysypart');

        formData.append("token", stored_cookie);
        //console.log("token = " + stored_cookie);

        setLoading(true);



        fetch(
            process.env.REACT_APP_API_URL + "myclass/api/AddStagiairetoClass_mass_for_many_session/",
            {
                method: 'POST',
                body: formData,
            }
        )
            .then((response) => response.json())
            .then((result) => {

                //console.log(" ## result['status'] = ", result['status'])
                if (String(result['status']) === String("Err_Connexion")) {
                    setLoading(false);
                    alert(result['message']);
                    history.push("/Connexion");
                }

                else if (String(result['status']) === String("true")) {
                    setLoading(false);
                    //console.log('Success:', result['message']);
                    setliste_apprenants_file_change_result(result['message']);
                    setliste_apprenants_file_change_api("true");

                    Get_All_Apprenant();
                    alert(result['message']);

                }

                else {
                    setLoading(false);
                    setliste_apprenants_file_change_message(result['message']);
                    setliste_apprenants_file_change_api("false");
                    alert(result['message']);

                }


            })
            .catch((error) => {
                setLoading(false);
                console.error('Error:', error);
                setliste_apprenants_file_change_api("false");
                alert(" Impossible d'importer les apprenants ");
            });
    }

    const hiddenFileInput_apprenant = React.useRef(null);
    const [apprenants_file_name, setapprenants_file_name] = useState();
    function submenu_import_apprenant() {
        setapprenants_file_name();
        setliste_apprenants_file_change_api();
        hiddenFileInput_apprenant.current.click();
    }

    const [add_One_Apprenant, setadd_One_Apprenant] = useState("");

    const [display_detail_apprenant, setdisplay_detail_apprenant] = useState("");
    const [display_detail_inscriptions, setdisplay_detail_inscriptions] = useState("");
    const [display_detail_absence, setdisplay_detail_absence] = useState("");
    const [display_detail_historique, setdisplay_detail_historique] = useState("");

    
    async function submenu_add_one_apprenant() {
        setsubmenu("");

        await sleep(5);

        setadd_One_Apprenant("1");

        setdisplay_detail_apprenant("");
        setdisplay_detail_inscriptions("");
        setdisplay_detail_absence("");
        setdisplay_detail_historique("");

    }



    async function submenu_detail_apprenant() {
        setsubmenu("detail_apprenant");

        await sleep(5);

        setdisplay_detail_apprenant("1");
        setadd_One_Apprenant("");
        setdisplay_detail_inscriptions("");
        setdisplay_detail_absence("");
        setdisplay_detail_historique("");

    }


    async function submenu_inscriptions() {
        setsubmenu("inscriptions");

        await sleep(5);

        setdisplay_detail_inscriptions("1");
        setadd_One_Apprenant("");
        setdisplay_detail_apprenant("");
        setdisplay_detail_absence("");
        setdisplay_detail_historique("");
    }

    async function submenu_absence() {
        setsubmenu("absences");

        await sleep(5);

        setdisplay_detail_absence("1");
        setadd_One_Apprenant("");
        setdisplay_detail_apprenant("");
        setdisplay_detail_inscriptions("");
        setdisplay_detail_historique("");
    }


    async function submenu_historique() {
        setsubmenu("historique");

        await sleep(5);

        setdisplay_detail_historique("1");
        setadd_One_Apprenant("");

        setdisplay_detail_apprenant("");
        setdisplay_detail_inscriptions("");
        setdisplay_detail_absence("");
    }


    const myRef = useRef(null)
    return (
        <div className="apprenant">

            {isLoading && <div className="loader-container">
                <div className="mysy_spinner">  <img src={img_loading_spin} />  </div>
            </div>}

            <Dialog
                open={Dialog_1_open}
                onClose={Dialog_1_handleClose}

            >

                <DialogTitle>MySy Information</DialogTitle>
                <DialogContent>
                    <DialogContentText>
                        {Dialog_1_message}
                    </DialogContentText>

                </DialogContent>

                <DialogActions>
                    <Button onClick={Dialog_1_handleClose_buton}>OK</Button>

                </DialogActions>
            </Dialog>

            <Dialog
                open={Dialog_2_open}
                onClose={Dialog_2_handleClose}
                className="displaypartnersession"
            >

                <div className="div_row_dialog">
                    <div className="div_row_gauche_dialog_session" style={{ "textAlign": 'left' }}>
                        Civilité
                    </div>
                    {Get_All_Apprenant_result && selected_apprenant_row_id && selected_apprenant_id &&
                        String(selected_apprenant_id).length > 0 && <div className="div_row_droite_dialog_session" style={{ "textAlign": 'right' }}>
                            {JSON.parse(Get_All_Apprenant_result[selected_apprenant_row_id]).civilite}
                        </div>}
                </div>

                <div className="div_row_dialog">
                    <div className="div_row_gauche_dialog_session" style={{ "textAlign": 'left' }}>
                        Nom
                    </div>
                    {Get_All_Apprenant_result && selected_apprenant_row_id && selected_apprenant_id &&
                        String(selected_apprenant_id).length > 0 && <div className="div_row_droite_dialog_session" style={{ "textAlign": 'right' }}>
                            {JSON.parse(Get_All_Apprenant_result[selected_apprenant_row_id]).nom}
                        </div>}
                </div>


                <div className="div_row_dialog">
                    <div className="div_row_gauche_dialog_session" style={{ "textAlign": 'left' }}>
                        Prénom
                    </div>
                    {Get_All_Apprenant_result && selected_apprenant_row_id && selected_apprenant_id &&
                        String(selected_apprenant_id).length > 0 && <div className="div_row_droite_dialog_session" style={{ "textAlign": 'right' }}>
                            {JSON.parse(Get_All_Apprenant_result[selected_apprenant_row_id]).prenom}
                        </div>}
                </div>

                <div className="div_row" > &nbsp;

                </div>

                <DialogActions>
                    <div className="div_row">
                        <div className="div_row_gauche">
                            <Button onClick={"Show_Detailled_Session_Data"} className="bton_enreg_dialog">Voir detail</Button>
                        </div>
                        <div className="div_row_droite" style={{ "textAlign": 'center' }}>
                            <Button onClick={"Dialog_2_handleClose_buton"} className="bton_annule_dialog" >Fermer</Button>
                        </div>
                    </div>

                </DialogActions>


            </Dialog>

            <h3> Vos apprenants </h3>
            <div>
                <div className="titre1">  Utilisez les filtres !</div>
                <div className="div_row" style={{ "marginBottom": "5px" }}>
                    <div className="div_row_gauche texte_area_filter" >
                        <TextField
                            name="filtre1"
                            label="Choisir un champ"
                            select
                            sx={{ m: 1, width: '100%' }}
                            value={p_filtre1}
                            onChange={(e) => {
                                setp_filtre1(e.target.value)
                            }}
                        >

                            <MenuItem value="email" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>Email &nbsp;&nbsp;</MenuItem>
                            <MenuItem value="nom" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Nom &nbsp;</MenuItem>
                            <MenuItem value="prenom" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Prénom &nbsp;</MenuItem>

                        </TextField>
                    </div>



                    <div className="div_row_droite texte_area_filter_value" >
                        {p_filtre1 &&
                            <TextField
                                sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                required
                                name="filtre1_value"
                                id="filtre1_value"

                                InputLabelProps={{
                                    shrink: true,
                                }}
                                disabled={false}
                                className="disabled_style"
                                value={p_filtre1_value}
                                onChange={(e) => { setp_filtre1_value(e.target.value); }}
                                InputProps={{
                                    endAdornment: (
                                        <InputAdornment position="end">
                                            <AiFillCloseCircle
                                                style={{ 'cursor': "pointer", "color": "orangered" }}
                                                onClick={(e) => {
                                                    setp_filtre1_value("");
                                                }} />
                                        </InputAdornment>
                                    ),
                                }}

                            />

                        }
                    </div>
                    {p_filtre1 && <div className='filter_bton_add'>
                        <Tooltip id="my-tooltip01" style={{ "fontSize": "12px" }} />
                        <a data-tooltip-id="my-tooltip01" data-tooltip-content="Ajouter une nouvelle ligne de filtre">
                            &nbsp; <MdAddCircleOutline onClick={(e) => {
                                setp_filtre2("1");
                            }} />
                        </a>
                    </div>}
                    {p_filtre1 && <div className='filter_bton_add'>
                        <Tooltip id="my-tooltip02" style={{ "fontSize": "12px" }} />
                        <a data-tooltip-id="my-tooltip02" data-tooltip-content="Supprimer cette ligne de filtre">
                            &nbsp; <MdRemoveCircleOutline onClick={(e) => {
                                setp_filtre1();
                                setp_filtre1_value();
                            }}
                            />
                        </a>
                    </div>}


                </div>

                {p_filtre2 &&
                    <div className="div_row" style={{ "marginBottom": "5px" }}>
                        <div className="div_row_gauche texte_area_filter">
                            <TextField
                                name="filtre2"
                                label="Choisir un champ"
                                select
                                sx={{ m: 1, width: '100%' }}
                                options={filters}
                                value={p_filtre2}
                                onChange={(e) => {
                                    setp_filtre2(e.target.value)
                                }}
                            >

                                <MenuItem value="email" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>Email &nbsp;&nbsp;</MenuItem>
                                <MenuItem value="nom" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Nom &nbsp;</MenuItem>
                                <MenuItem value="prenom" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Prénom &nbsp;</MenuItem>

                            </TextField>
                        </div>
                        <div className="div_row_droite texte_area_filter" >
                            {String(p_filtre2).length > 3 &&
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="filtre2_value"
                                    id="filtre2_value"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_filtre2_value}
                                    onChange={(e) => setp_filtre2_value(e.target.value)}
                                    InputProps={{
                                        endAdornment: (
                                            <InputAdornment position="end">
                                                <AiFillCloseCircle
                                                    style={{ 'cursor': "pointer", "color": "orangered" }}
                                                    onClick={(e) => {
                                                        setp_filtre2_value("");
                                                    }} />
                                            </InputAdornment>
                                        ),
                                    }}

                                />}
                        </div>


                        {String(p_filtre2).length > 3 && <div className='filter_bton_add'>
                            <Tooltip id="my-tooltip04" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip04" data-tooltip-content="Supprimer cette ligne de filtre">
                                &nbsp; <MdRemoveCircleOutline
                                    onClick={(e) => {
                                        setp_filtre2();
                                        setp_filtre2_value();
                                    }}
                                />
                            </a>
                        </div>}
                    </div>
                }


                {<div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                    <div className="div_row_gauche" style={{ "textAlign": 'left', 'marginLeft': '15px' }}>
                        <Button variant="contained" className="bton_enreg" onClick={Get_All_Apprenant}>Rechercher
                        </Button>
                    </div>

                    <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>
                        <Button variant="contained" className="bton_annule" onClick={clean_all_filters}>Annuler
                        </Button>

                    </div>

                </div>}

            </div>
            <br />
            <div style={{ "textAlign": "left", "float": "left", "width": "100%", "paddingRight": "10px" }} id="participant_menu_tab">

                <div className="session_data">
                    <div style={{ "border": "None" }}>

                        <div style={{ height: 550, width: '100%', paddingRight: '5px' }}>
                            &nbsp;
                            <Box
                                sx={{
                                    height: 500,
                                    width: '100%',
                                    paddingRight: '1px',
                                    '& .cell--presentiel': {
                                        backgroundColor: '#a2cf6e',
                                        color: '#1a3e72',
                                        fontWeight: 'bold',
                                    },
                                    '& .cell--distantiel': {
                                        backgroundColor: '#ffac33',
                                        color: '#1a3e72',
                                        fontWeight: 'light',
                                    },


                                    '& .cell--etape--projet': {
                                        backgroundColor: '#E6F7C8',
                                        color: '#1a3e72',
                                        fontWeight: 'light',
                                    },
                                    '& .cell--etape--planification': {
                                        backgroundColor: '#E6CEAA',
                                        color: '#1a3e72',
                                        fontWeight: 'light',
                                    },
                                    '& .cell--etape--planifie': {
                                        backgroundColor: '#F4ECF7',
                                        color: '#1a3e72',
                                        fontWeight: 'light',
                                    },
                                    '& .cell--etape--termine': {
                                        backgroundColor: '#D6EAF8',
                                        color: '#1a3e72',
                                        fontWeight: 'light',
                                    },
                                    '& .cell--etape--facture': {
                                        backgroundColor: '#D5F5E3',
                                        color: '#1a3e72',
                                        fontWeight: 'light',
                                    },
                                    '& .cell--etape--annule': {
                                        backgroundColor: '#566573',
                                        color: '#1a3e72',
                                        fontWeight: 'light',
                                    },


                                    '& .line--etape--projet': {
                                        backgroundColor: 'yellow',
                                        color: 'black',
                                    },
                                    '& .line--etape--planification': {
                                        backgroundColor: 'red',
                                        color: 'black',
                                    },
                                    '& .line--etape--planifie': {
                                        backgroundColor: 'blue',
                                        color: 'black',
                                    },
                                    '& .line--etape--termine': {
                                        backgroundColor: 'orange',
                                        color: 'black',
                                    },
                                    '& .line--etape--facture': {
                                        backgroundColor: '#D5F5E3',
                                        color: 'black',
                                    },
                                    '& .line--etape--annule': {
                                        backgroundColor: '#566573',
                                        color: 'white',
                                    },
                                    "& .MuiDataGrid-columnHeaders": {
                                        backgroundColor: "#c8cfd5",
                                        color: "black",
                                        fontSize: 14
                                    },

                                    '& .line--statut--selected': {
                                        backgroundColor: '#FBF2EF',
                                        color: 'black',
                                    },
                                    '& .line--statut--pair': {
                                        backgroundColor: 'rgba(235, 235, 235, .7)',
                                        color: 'black',
                                    },
                                    '& .line--statut--impair': {
                                        backgroundColor: '#FFFFFF',
                                        color: 'black',
                                    },

                                }}
                            >
                                <DataGrid
                                    checkboxSelection

                                    onSelectionModelChange={(newSelectionModel) => {
                                        setSelectionModel(newSelectionModel);
                                        /*if (newSelectionModel.length === 1)
                                            handleClick_edit_session_From_Line(newSelectionModel);*/
                                        if (newSelectionModel.length !== 1) {
                                            /*  setaddOneParticipant();
                                              setdisplay_detail_insc();
                                              setselected_code_session();*/
                                            setsubmenu();
                                        }
                                    }}
                                    selectionModel={selectionModel}

                                    localeText={frFR.components.MuiDataGrid.defaultProps.localeText}
                                    rows={Get_All_Apprenant_result.map((item, index) => (
                                        {
                                            id: index,
                                            _id: JSON.parse(item)._id,
                                            civilite: JSON.parse(item).civilite,
                                            nom: JSON.parse(item).nom,
                                            prenom: JSON.parse(item).prenom,
                                            email: JSON.parse(item).email,

                                        }
                                    ))}

                                    columns={columns}
                                    pageSize={10}
                                    className="datagridclass"

                                    onRowDoubleClick={(newSelectionModel) => {
                                        setgridline_id(newSelectionModel.row.id);
                                        setselected_apprenant_id(newSelectionModel.row._id);
                                        setselected_apprenant_row_id(newSelectionModel.row.id);


                                        setDialog_2_message(String(JSON.parse(Get_All_Apprenant_result[newSelectionModel.row.id]).title));
                                        setDialog_2_open(true);

                                    }}



                                    rowsPerPageOptions={[10]}
                                    disableSelectionOnClick
                                    components={{
                                        Toolbar: GridToolbar,
                                    }}
                                    //sx={datagridSx}
                                    getCellClassName={(params) => {
                                        //field === 'distantiel'
                                        if (params.field === 'distantiel' && String(params.value) === "1") {
                                            return 'cell--distantiel';
                                        }
                                        if (params.field === "presentiel" && String(params.value) == "1") {
                                            return 'cell--presentiel';
                                        }


                                        //field === "etape"
                                        if (params.field === "etape" && String(params.value) == "0") {
                                            return 'cell--etape--projet';
                                        }

                                        if (params.field === "etape" && String(params.value) == "1") {
                                            return 'cell--etape--planification';
                                        }

                                        if (params.field === "etape" && String(params.value) == "2") {
                                            return 'cell--etape--planifie';
                                        }

                                        if (params.field === "etape" && String(params.value) == "3") {
                                            return 'cell--etape--termine';
                                        }

                                        if (params.field === "etape" && String(params.value) == "4") {
                                            return 'cell--etape--facture';
                                        }

                                        if (params.field === "etape" && String(params.value) == "-1") {
                                            return 'cell--etape--annule';
                                        }

                                        // Pour la gestion de la couleur de zone double cliquée
                                        if (String(params.row.id) === String(gridline_id)) {
                                            return 'line--statut--selected';
                                        }
                                        else if (parseInt(String(params.row.id)) % 2 === 0) {
                                            return 'line--statut--pair';
                                        }
                                        else if (parseInt(String(params.row.id)) % 2 !== 0) {
                                            return 'line--statut--impair';
                                        }

                                    }}


                                />
                            </Box>
                            <br />

                        </div>

                        <div className="div_row">

                            {selectionModel && selectionModel.length >= 1 && <div className="block_en_mass">
                                <nav >Traitement en masse </nav>
                                &nbsp;
                                <TextField

                                    select
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    inputProps={{ min: "0", max: "1", step: "1" }}
                                    disabled={false}
                                    className="block_en_mass_select"

                                    value={actionmass_ftion_val}
                                    onChange={actionmass_ftion}
                                >
                                    <MenuItem value="n/a" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>Action &nbsp;&nbsp;</MenuItem>
                                    <MenuItem value="supprimer" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>Supprimer &nbsp;</MenuItem>
                                    <MenuItem value="dupliquer" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>Dupliquer &nbsp;</MenuItem>
                                </TextField>


                                {actionmass_ftion_val && <nav className='block_en_mass_bton_action'>
                                    <Popup
                                        trigger={<Button className="bton_enreg" style={{ "width": "90%" }}>

                                            <FcAcceptDatabase /> Traiter

                                        </Button>}
                                        modal
                                        nested
                                        position="center center"

                                    >

                                        {close => (
                                            <div>
                                                <button className="gest_close" onClick={close}>
                                                    &times;
                                                </button>
                                                <div className="gest_header"> MySy Information </div>
                                                <div className="gest_content">
                                                    {' '}

                                                    <font color="red">  Confirmer l'action <b> {actionmass_ftion_val} </b> en masse pour {selectionModel.length} lignes.
                                                    </font>
                                                </div>
                                                <div className="gest_actions">
                                                    <div style={{ "width": "45%", "float": "left" }}>
                                                        <button className="gest_bton_popup" onClick={(event) => {
                                                            actionmass_ftion_Traitemet();
                                                            close();
                                                        }}> Valider </button>

                                                    </div>
                                                    <div style={{ "width": "45%", "float": "right" }}>
                                                        <button
                                                            className="gest_bton_popup"
                                                            onClick={() => {
                                                                //console.log('modal closed ');
                                                                close();
                                                            }}
                                                        >
                                                            Annuler
                                                        </button>
                                                    </div>
                                                </div>
                                            </div>
                                        )}
                                    </Popup>
                                </nav>
                                }

                            </div>}
                        </div>

                    </div>

                </div>
            </div>

            <div className="div_row" style={{ "border": "None" }}>

                <div className="div_row_gauche div_row_gauche_etendu" style={{ "textAlign": "left", "paddingLeft": "5px" }}>

                    <Button variant="outlined" onClick={"submenu_import_stagiaire"} className="detail_class_submenu bton_import_excel"
                        id='menu_import_participant' name='menu_import_participant'>Importer des apprenants excel &nbsp;
                        <img src={excel_icone} alt="ajout csv" className="icon_excel" />
                    </Button>


                    <Button variant="outlined" onClick={submenu_add_one_apprenant}
                        className="detail_class_submenu bton_add_session"
                        id='menu_import_participant' name='menu_import_participant'>Ajouter 1 apprenant &nbsp;
                        <img src={add_plus} alt="ajout session" className="icon_plus" />
                    </Button>

                    <br />
                    {apprenant_file_name && <nav><i>{apprenant_file_name}</i></nav>}
                    {String(liste_apprenants_file_change_api) === String("true") && <nav className="okUpdateData"> Les apprenants ont été correctement importés</nav>}
                    {String(liste_apprenants_file_change_api) === String("false") && <nav className="koUpdateData"> {liste_apprenants_file_change_message} </nav>}

                    <input type="file"
                        accept=".csv"
                        ref={hiddenFileInput_apprenant}
                        style={{ display: 'none' }}
                        name="liste_apprenants_file"
                        onChange={liste_apprenants_file_change}
                    />

                    <a href='/sample/template_import_stagiaires.csv' download>Télécharger un fichier modèle</a>
                </div>
            </div>

            <div className="div_row" ref={myRef_details} id="myRef_details"> &nbsp;</div>

            display_detail_apprenant = {display_detail_apprenant} <br/>
            add_One_Apprenant = {add_One_Apprenant} <br/>


            {((selected_apprenant_id && String(selected_apprenant_id).length > 2) || (String(add_One_Apprenant) === "1")) && <div className="div_row">
                <Button variant="outlined" ref={myRef} onClick={submenu_detail_apprenant} className="detail_class_submenu" id='detail_apprenant' name='detail_apprenant'>Détail Apprenant</Button>
                <Button variant="outlined" onClick={submenu_inscriptions} className="detail_class_submenu" id='inscriptions' name='inscriptions'>Inscriptions </Button>
                <Button variant="outlined" onClick={submenu_absence} className="detail_class_submenu" id='absences' name='absences'>Absences </Button>
                <Button variant="outlined" onClick={submenu_historique} className="detail_class_submenu" id='historique' name='historique'>Historique </Button>

            </div>}

            {String(add_One_Apprenant) === "1" && <div className="div_row session_data" style={{ "border": "None", "backgroundColor": "#F0F0F0" }}>

                <nav style={{ "border": "None", "fontSize": "22px", "fontWeight": "600" }}>Ajout d'un nouvel apprenant </nav>

                <div className="session_caract"> <b> Civilité </b> <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_nom_part"
                        id="one_nom_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_civilite}
                        onChange={(e) => {
                            setp_one_civilite(e.target.value);
                        }
                        }

                    />
                </div>


                <div className="session_caract"> <b> Nom </b> <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_nom_part"
                        id="one_nom_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_nom}
                        onChange={(e) => {
                            setp_one_nom(e.target.value);
                        }
                        }

                    />
                </div>


                <div className="session_caract"> <b> Prénom </b><br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_prenom_part"
                        id="one_prenom_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_prenom}
                        onChange={(e) => {
                            setp_one_prenom(e.target.value);
                        }
                        }
                    />
                </div>

                <div className="session_caract"> <b> Email </b><br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_email_part"
                        id="one_email_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_email}
                        onChange={(e) => {
                            setp_one_email(e.target.value);
                        }
                        }
                    />
                </div>

                <div className="session_caract"> <b> Téléphone </b> <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_phone_part"
                        id="one_phone_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_telephone}
                        onChange={(e) => {
                            setp_one_telephone(e.target.value);
                        }
                        }
                    />
                </div>


                <div className="session_caract"> Adresse <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_adresse_part"
                        id="one_adresse_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_adresse}
                        onChange={(e) => {
                            setp_one_adresse(e.target.value);
                        }
                        }
                    />
                </div>


                <div className="session_caract"> Code postal <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_code_postal_part"
                        id="one_code_postal_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_code_postal}
                        onChange={(e) => {
                            setp_one_code_postal(e.target.value);
                        }
                        }
                    />
                </div>


                <div className="session_caract"> Ville <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_ville_part"
                        id="one_ville_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_ville}
                        onChange={(e) => {
                            setp_one_ville(e.target.value);
                        }
                        }
                    />
                </div>

                <div className="session_caract"> Pays <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="one_pays_part"
                        id="one_pays_part"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_one_pays}
                        onChange={(e) => {
                            setp_one_pays(e.target.value);
                        }
                        }
                    />
                </div>



            </div>}
          

            {String(display_detail_apprenant) === "1" && String(add_One_Apprenant) !== "1" && selected_apprenant_id && <div className="div_row" style={{ "border": "None", "background": '#F8F9F9', "padding": '5px' }}>
                <nav style={{ "border": "None", "fontSize": "22px", "fontWeight": "600" }}> Détail Apprenant </nav>

                <div className="session_caract"> <b> Civilité </b> <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_civilite"
                        id="field_detail_civilite"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_civilite}
                        onChange={(e) => {
                            setp_detail_civilite(e.target.value);
                        }
                        }

                    />
                </div>

                <div className="session_caract"> <b> Nom </b> <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_nom"
                        id="field_detail_nom"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_nom}
                        onChange={(e) => {
                            setp_detail_nom(e.target.value);
                        }
                        }

                    />
                </div>


                <div className="session_caract"> <b> Prénom </b><br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_prenom"
                        id="field_detail_prenom"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_prenom}
                        onChange={(e) => {
                            setp_detail_prenom(e.target.value);
                        }
                        }
                    />
                </div>

                <div className="session_caract"> <b> Email </b><br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_email"
                        id="field_detail_email"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_email}
                        onChange={(e) => {
                            setp_detail_email(e.target.value);
                        }
                        }
                    />
                </div>

                <div className="session_caract"> <b> Téléphone </b> <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_telephone"
                        id="field_detail_telephone"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_telephone}
                        onChange={(e) => {
                            setp_detail_telephone(e.target.value);
                        }
                        }
                    />
                </div>


                <div className="session_caract"> Adresse <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_adresse"
                        id="field_detail_adresse"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_adresse}
                        onChange={(e) => {
                            setp_detail_adresse(e.target.value);
                        }
                        }
                    />
                </div>


                <div className="session_caract"> Code postal <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_code_postal"
                        id="field_detail_code_postal"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_code_postal}
                        onChange={(e) => {
                            setp_detail_code_postal(e.target.value);
                        }
                        }
                    />
                </div>


                <div className="session_caract"> Ville <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_ville"
                        id="field_detail_ville"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_ville}
                        onChange={(e) => {
                            setp_detail_ville(e.target.value);
                        }
                        }
                    />
                </div>

                <div className="session_caract"> Pays <br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="field_detail_pays"
                        id="field_detail_pays"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        disabled={false}
                        className="disabled_style enable_style"
                        value={p_detail_pays}
                        onChange={(e) => {
                            setp_detail_pays(e.target.value);
                        }
                        }
                    />
                </div>



            </div>}

            {String(display_detail_inscriptions) === "1" && String(add_One_Apprenant) !== "1" && selected_apprenant_id && <div className="div_row" style={{ "border": "None", "background": '#F8F9F9', "padding": '5px' }}>
                <nav style={{ "border": "None", "fontSize": "22px", "fontWeight": "600" }}> Détail des inscriptions </nav>

            </div>}

            {String(display_detail_absence) === "1" && String(add_One_Apprenant) !== "1" && selected_apprenant_id && <div className="div_row" style={{ "border": "None", "background": '#F8F9F9', "padding": '5px' }}>
                <nav style={{ "border": "None", "fontSize": "22px", "fontWeight": "600" }}> Détail des absences </nav>

            </div>}

            {String(display_detail_historique) === "1" && String(add_One_Apprenant) !== "1" && selected_apprenant_id && <div className="div_row" style={{ "border": "None", "background": '#F8F9F9', "padding": '5px' }}>
                <nav style={{ "border": "None", "fontSize": "22px", "fontWeight": "600" }}> Historique </nav>

            </div>}

        </div >
    );
}

export default Apprenant;